#include <stdio.h>
#include <stdlib.h>
#include <obstack.h>

#define obstack_chunk_alloc malloc
#define obstack_chunk_free free

struct obstack function;
unsigned int numfunction = 1;
unsigned int pc;

void
function_free(void)
{
  obstack_free(&function, obstack_finish(&function));
}

void
function_init(void)
{
  obstack_init(&function);
  obstack_int_grow(&function, 0);
}

unsigned int
getfuncaddr(unsigned int i)
{
  unsigned int *funcs = (unsigned int *) obstack_base(&function);
  return funcs[i];
}

unsigned int
addfunction(unsigned int addr)
{
  unsigned int i;
  unsigned int *funcs;

  funcs = (unsigned int *) obstack_base(&function);

  for (i = 0 ; i < numfunction ; i++) {
    if (funcs[i] == addr) {
      return i;
    }
  }

  obstack_int_grow(&function, (signed int)addr);
  numfunction++;
  return numfunction-1;
}

